
;
; Quick musicplayer hack 19.3.2004 Tim Boescke (Bionic/Synergy)
; Should play single speed SID tunes without digis between $0700 and $FD00
; Obviously, most of the code is just an elaborate copy routine..
;
; This source compiles with ACME, which can be found here:
; http://home.pages.de/~mac_bacon/cpf/acme.html
;

    !to "musicplayer.prg"
	*=$1001
	!word $100B,0
	!byte $9E,$34,$31,$30,$39,0,0,0
	;


main
	sei
	lsr $ff06
	lda #$21
	sta $ff19
	sta	$ff3f

	lda  #<tune
	sta  $d0
	lda  #>tune
	sta  $d1

	ldx  #9
.lop3
	lda	 tunestart,x
	sta	 $d2,x
	dex
	bpl	 .lop3

	ldx #pe-pa
.lop
	lda	player-1,x
	sta	$0600-1,x
	dex
	bne	.lop
	jmp $0600

;This will be relocated to $0600, take care of addressing..
player
	   !pseudopc $0600
pa
  	  lda $d1
  	  cmp $d3
  	  beq .sub
  	  bcs .forward
  	  bcc .backward
.sub
	  lda $d0
	  cmp $d2
	  bcc .backward

	  ;forward copy
.forward
	  ldy #0
	  ldx $d5
	  beq .skop
.lop1
	  lda ($d0),y
	  sta ($d2),y
	  iny
	  bne .lop1
	  inc $d1
	  inc $d3
	  dex
	  bne .lop1
.skop
	  ldx $d4
	  beq .nofrac
.lop2
	  lda ($d0),y
	  sta ($d2),y
	  iny
	  dex
	  bne .lop2
.nofrac
	  jmp .weiter
	  ;backward copy
.backward
	  lda $d5
	  clc
	  adc $d1
	  sta $d1
	  lda $d5
	  adc $d3
	  sta $d3

	  ldy $d4
	  beq .nofrac2
.lop4
	  dey
	  lda ($d0),y
	  sta ($d2),y
	  tya
	  bne .lop4
.nofrac2

	  ldx $d5
	  beq .skop2
.skop2
	  dec $d1
	  dec $d3
	  ldy #0
.lop5
	  dey
	  lda ($d0),y
	  sta ($d2),y
	  tya
	  bne .lop5

	  dex
	  bne .skop2

.weiter
	  lda $da
	  jsr init
.loop
	  lda #$70
.wait
	  cmp $ff1d
	  bne .wait
	  lda #$77
	  sta $ff19
	  jsr play
	  lda #$21
	  sta $ff19
	  bne .loop
init: jmp ($00d6)
play: jmp ($00d8)
pe
	  !realpc

tunestart

;		  !word $1000           ;d2 tunestart
;tunelen!word $1bb1           ;d4 tunelen
;tuneinit  !word $1000            ;d6 tuneinit
;tuneplay  !word $1003            ;d8 tuneplay
;initvalue !byte 0                ;da initvalue

tune =tunestart+2*4+1

;tune:
;		!binary "solarumlirum.bin"
;		!binary "gloria.bin"

